package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.TipoTarifaPacoteDAO;
import com.rjconsultores.ventaboletos.entidad.Pacote;
import com.rjconsultores.ventaboletos.entidad.TipoTarifaPacote;
import com.rjconsultores.ventaboletos.service.TipoTarifaPacoteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("tipoTarifaPacoteService")
public class TipoTarifaPacoteServiceImpl implements TipoTarifaPacoteService {

	@Autowired
	private TipoTarifaPacoteDAO tipoTarifaPacoteDAO;

	@Override
	public List<TipoTarifaPacote> obtenerTodos() {
		return tipoTarifaPacoteDAO.obtenerTodos();
	}

	@Override
	public TipoTarifaPacote obtenerID(Integer id) {
		return tipoTarifaPacoteDAO.obtenerID(id);
	}

	@Transactional
	@Override
	public TipoTarifaPacote suscribir(TipoTarifaPacote entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return tipoTarifaPacoteDAO.suscribir(entidad);
	}

	@Transactional
	@Override
	public TipoTarifaPacote actualizacion(TipoTarifaPacote entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return tipoTarifaPacoteDAO.actualizacion(entidad);
	}

	@Transactional
	@Override
	public void borrar(TipoTarifaPacote entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		tipoTarifaPacoteDAO.actualizacion(entidad);
	}

	@Override
	public List<TipoTarifaPacote> buscaTipoTarifaPacote(Pacote pacote) {
		return tipoTarifaPacoteDAO.buscaTipoTarifaPacote(pacote);
	}
}
